// C Source File
// Created 05.03.03; 20:16:39


//   ****************************************
//   *           Sim2Chat by Hofi           *
//   *                 v1.1                 *
//   *        Simultan Chat Programm        *
//   ****************************************


#define USE_TI92PLUS          // Produce .9xz File
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <tigcclib.h>         // Include All Header Files

void error_info(int, int);
int getdata(int*,int);
int senddata(int*);

// Main Function
void _main(void)
{
	int tmp = 0;
	long tmp1 = 0;
	char run = 1;
	int ch = 0;
	char empty[40] = "                                       ";
	char nick_a[11] = {0,0,0,0,0,0,0,0,0,0,0};
	char nick_b[11];
	struct history
	{
		char s1[40];
		char s2[40];
		char s3[40];
		char s4[40];
		char s5[40];
		char s6[40];
		int pos;
	} user_a;
	struct history user_b;
	
	FILE *fp;
	fp = fopen ("main\\sim2nick", "r");
	if(fp != NULL)
	{
		for(ch = 0; ch < 11; ch++)
		{
			nick_a[ch] = fgetc(fp);
		}
		fclose(fp);
	}
	else
	{	
		fp = fopen ("main\\sim2nick", "wb");
		fputc (0, fp);
		fputc (0, fp);
		fputc (0, fp);
		for(ch = 0; ch < 11; ch++)
		{
			fputc(nick_a[ch], fp); 
		}
		fputc (0, fp);
		fputs ("S2N", fp);
		fputc (0, fp);
		fputc (OTH_TAG, fp);
		fclose (fp);
	}
	
	restart:
	strcpy(user_a.s1,empty);
	strcpy(user_a.s2,empty);
	strcpy(user_a.s3,empty);
	strcpy(user_a.s4,empty);
	strcpy(user_a.s5,empty);
	strcpy(user_a.s6,empty);
	
	strcpy(user_b.s1,empty);
	strcpy(user_b.s2,empty);
	strcpy(user_b.s3,empty);
	strcpy(user_b.s4,empty);
	strcpy(user_b.s5,empty);
	strcpy(user_b.s6,empty);
	
	clrscr();
	FontSetSys(F_8x10);
	if(run)
	{
		for(tmp = -10; tmp < 16; tmp++)
		{
			for(tmp1 = 0; tmp1 < 1000000; tmp1++);
			printf_xy(56,tmp,"Sim2Chat by Hofi");
			if(tmp >= 0) DrawLine(0,tmp-1,239,tmp-1,A_REVERSE);
		}
	}
	else printf_xy(56,15,"Sim2Chat by Hofi");
	run = 0;
	FontSetSys(F_6x8);
	printf_xy(20,50,"Enter: Start Synchronisation");
	printf_xy(20,60,"Apps:  Help & About");
	printf_xy(20,70,"Esc:   Quit Program");
	printf_xy(20,80,"Space: Change Nickname");
	printf_xy(20,90,"Nick:  %s",nick_a);
	printf_xy(209,119,"v1.2c");
	
	tmp = 0;
	while(tmp != 13 && tmp != 264 && tmp != 265 && tmp != 32) tmp = ngetchx();
	if(tmp == 265)
	{
		clrscr();
		FontSetSys(F_8x10);
		printf_xy(56, 10, "Sim2Chat by Hofi");
		printf_xy(72, 22, "Help & About");
		FontSetSys(F_6x8);
		printf_xy(20, 36, "Connecting:");
		printf_xy(20, 44, "Connect by pressing enter in the");
		printf_xy(20, 52, "main screen, approximately when");
		printf_xy(20, 60, "the other user does it.");
		printf_xy(20, 72, "In the chat:");
		printf_xy(20, 80, "Enter: Move the history up and");
		printf_xy(20, 88, "       create a new line.");
		printf_xy(20, 96, "Clear: Clear the entry line.");
		printf_xy(20, 104, "Esc:   Exit the Chat (The other");
		printf_xy(20, 112, "       user will be informed).");
		
		ngetchx();
		clrscr();
		FontSetSys(F_8x10);
		printf_xy(56, 10, "Sim2Chat by Hofi");
		printf_xy(72, 22, "Help & About");
		FontSetSys(F_6x8);
		printf_xy(20, 36, "Chatting:");
		printf_xy(20, 44, "You type in the lower half, ");
		printf_xy(20, 52, "the other user in the other one.");
		printf_xy(20, 60, "The halves will always contain");
		printf_xy(20, 68, "the same.");
		printf_xy(20, 80, "Program and copyright by:");
		printf_xy(20, 88, "Christian Hofstadler, ");
		printf_xy(20, 96, "March 2003");
		printf_xy(20,108, "Added: Save Nickname without");
		printf_xy(20,116, "unarchiving program.");
		ngetchx();
		run = 1;
		goto restart;
	}
	if(tmp == 264) goto end_chat;
	if(tmp == 32)
	{
		for(tmp = 0; tmp < 11; tmp++) nick_a[tmp] = 0; 
		tmp = 0;
		printf_xy(62,90,"_          ");
		do
		{
			ch = ngetchx();
			if(ch == 257 && tmp)
			{
				tmp--;
				printf_xy(tmp*6+62,90,"_ ");
				nick_a[tmp] = 0;
			}
			if(ch < 256 && ch != 13 && ch != 0 && tmp < 10)
			{
				printf_xy(tmp*6+62,90,"%c_",ch);
				nick_a[tmp] = ch;
				tmp++;
			}
		} while(ch != 13 && ch != 264);
		printf_xy(tmp*6+62,90," ");
		
		fp = fopen ("main\\sim2nick", "wb");
		fputc (0, fp);
		fputc (0, fp);
		fputc (0, fp);
		for(ch = 0; ch < 11; ch++)
		{
			fputc(nick_a[ch], fp); 
		}
		fputc (0, fp);
		fputs ("S2N", fp);
		fputc (0, fp);
		fputc (OTH_TAG, fp);
		fclose (fp);
		
		goto restart;
	}
	
	user_a.pos = 0;
	user_b.pos = 0;
	tmp1 = 0;
	ch = 0xFFFF;
	error_info(4,0);
	tmp = getdata(&ch, 40);
	tmp1 = tmp;
	tmp = senddata(&ch);
	if(tmp1) tmp = getdata(&ch,5);
	if(tmp)
	{
		error_info(3,1);
		goto restart;
	}
	
	if(tmp1) 
	{
		for(ch = 0; ch < 50; ch++);
		LIO_SendData(&nick_a,10);
	}
	LIO_RecvData(&nick_b,10,5);
	if(!(tmp1))
	{
	 	for(ch = 0; ch < 50; ch++);
	 	LIO_SendData(&nick_a,10);
	}
	
	clrscr();
	DrawLine(0, 66, 239, 66, A_NORMAL);
	DrawLine(0, 68, 239, 68, A_NORMAL);
	run = 1;
	
	FontSetSys(F_6x8);
	printf_xy(12, 2, "Sim2Chat    Connected to:");
	for(tmp = 0; tmp < 10; tmp++) printf_xy(168+6*tmp,2,"%c",nick_b[tmp]);
	printf_xy(3, 115, "_");
	if(kbhit()) ngetchx();
	if(!(tmp1)) goto recv;
	for(tmp = 0; tmp < 100; tmp++);
	if(tmp1) goto snd;
	
	snd:
	ch = 0;
	if(kbhit()) ch = ngetchx();
	if(ch > 255 && ch != 257 && ch != 263 && ch != 264) ch = 0;
	tmp = senddata(&ch);
	if(tmp)
	{
		error_info(1,1);
		goto restart;
	}
	if(ch == 257 && user_a.pos)
	{
		user_a.pos--;
		printf_xy(user_a.pos*6+3, 115, "_ ");
		user_a.s1[user_a.pos] = 32;
	}
	if(ch == 263)
	{
		user_a.pos = 0;
		printf_xy(3,115,"_                                       ");
		strcpy(user_a.s1,empty);
	}
	if(ch == 264) goto restart;
	if(ch < 256 && ch > 0 && ch != 13)
	{
		printf_xy(user_a.pos*6+3, 115, "%c_",(char)ch);
		user_a.s1[user_a.pos] = ch;
		user_a.pos++;
	}
	if(ch == 13)
	{ 
		printf_xy(user_a.pos*6+3, 115, " ");
		user_a.pos = 39;
	}
	if(user_a.pos > 38)
	{
		strcpy(user_a.s6,user_a.s5);
		strcpy(user_a.s5,user_a.s4);
		strcpy(user_a.s4,user_a.s3);
		strcpy(user_a.s3,user_a.s2);
		strcpy(user_a.s2,user_a.s1);
		strcpy(user_a.s1,empty);
		printf_xy(3,115,"_                                       ");
		DrawStr(3,107,user_a.s2,A_REPLACE);
		DrawStr(3, 99,user_a.s3,A_REPLACE);
		DrawStr(3, 91,user_a.s4,A_REPLACE);
		DrawStr(3, 83,user_a.s5,A_REPLACE);
		DrawStr(3, 75,user_a.s6,A_REPLACE);
		user_a.pos = 0;
	}
	
	recv:
	tmp = getdata(&ch,4);
	if(tmp)
	{
		error_info(1,1);
		goto restart;
	}
	if(ch == 257 && user_b.pos)
	{
		user_b.pos--;
		printf_xy(user_b.pos*6+3, 53, " ");
		user_b.s1[user_b.pos] = 32;
	}
	if(ch == 263)
	{
		user_b.pos = 0;
		printf_xy(3,53,"                                       ");
		strcpy(user_b.s1,empty);
	}
	if(ch == 264)
	{
		error_info(2,1);
	 	goto restart;
	}
	if(ch < 256 && ch > 0 && ch != 13)
	{
		printf_xy(user_b.pos*6+3, 53, "%c",(char)ch);
		user_b.s1[user_b.pos] = ch;
		user_b.pos++;
	}
	if(ch == 13) user_b.pos = 39;
	if(user_b.pos > 38)
	{
		strcpy(user_b.s6,user_b.s5);
		strcpy(user_b.s5,user_b.s4);
		strcpy(user_b.s4,user_b.s3);
		strcpy(user_b.s3,user_b.s2);
		strcpy(user_b.s2,user_b.s1);
		strcpy(user_b.s1,empty);
		printf_xy(3, 53,"                                       ");
		DrawStr(3, 45,user_b.s2,A_REPLACE);
		DrawStr(3, 37,user_b.s3,A_REPLACE);
		DrawStr(3, 29,user_b.s4,A_REPLACE);
		DrawStr(3, 21,user_b.s5,A_REPLACE);
		DrawStr(3, 13,user_b.s6,A_REPLACE);
		user_b.pos = 0;
	}
	FontSetSys(F_6x8);
	goto snd;
	end_chat:
	FontSetSys(F_8x10);
	for(tmp = 15; tmp > -11; tmp--)
	{
		for(tmp1 = 0; tmp1 < 1000000; tmp1++);
		printf_xy(56,tmp,"Sim2Chat by Hofi");
		if(tmp >= 0) DrawLine(0,tmp+10,239,tmp+10,A_REVERSE);
	}
}

int getdata(int *ptr, int timer)
{
	return(LIO_RecvData((void*)ptr,2,(unsigned long)timer));
}

int senddata(int *ptr)
{
	return(LIO_SendData((void*)ptr,2));
}

void error_info(int error_code, int wait)
{
	int line;
	for(line = 46; line < 82; line++) DrawLine(18, line, 222, line, A_REVERSE);
	DrawLine (18,46,222,46,A_NORMAL);
	DrawLine (18,82,222,82,A_NORMAL);
	DrawLine (18,46,18,82,A_NORMAL);
	DrawLine (222,46,222,82,A_NORMAL);
	DrawLine (20,48,220,48,A_NORMAL);
	DrawLine (20,80,220,80,A_NORMAL);
	DrawLine (20,48,20,80,A_NORMAL);
	DrawLine (220,48,220,80,A_NORMAL);
	FontSetSys(F_8x10);
	if(error_code == 1) printf_xy(40, 56, "Synchronisation lost");
	if(error_code == 2) printf_xy(36, 56, "User has disconnected");
	if(error_code == 3) printf_xy(32, 56, "Synchronisation failed");
	if(error_code == 4) printf_xy(44, 56, "Waiting for Synchro");
	FontSetSys(F_4x6);
	if(error_code != 4)printf_xy(75, 70, "Press any key to continue");	
	if(wait) ngetchx();
}

